# EXAMPLE REQUEST 1: Serverless index (on-demand)
# Enable deletion protection and add tags to an
# existing on-demand index.
PINECONE_API_KEY="YOUR_API_KEY"
INDEX_NAME="YOUR_INDEX_NAME"
curl -X PATCH "https://api.pinecone.io/indexes/$INDEX_NAME" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2025-10" \
-d '{
"deletion_protection": "enabled",
"tags": {
"tag1": "value1",
"tag2": "value2"
}
}'
# EXAMPLE REQUEST 2: Serverless index (dedicated)
# Add a replica to an existing dedicated index.
PINECONE_API_KEY="YOUR_API_KEY"
INDEX_NAME="YOUR_INDEX_NAME"
curl -X PATCH "https://api.pinecone.io/indexes/$INDEX_NAME" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2025-10" \
-d '{
"spec": {
"serverless": {
"read_capacity": {
"mode": "Dedicated",
"dedicated": {
"node_type": "b1",
"scaling": "Manual",
"manual": {
"shards": 2,
"replicas": 2
}
}
}
}
}
}'
// EXAMPLE RESPONSE 1: Serverless index (on-demand)
// Enable deletion protection and add tags to an
// existing on-demand index.
{
"name": "example-serverless-ondemand-index",
"vector_type": "dense",
"metric": "cosine",
"dimension": 1024,
"status": {
"ready": true,
"state": "Ready"
},
"host": "example-serverless-ondemand-index-bhnyigt.svc.aped-4627-b74a.pinecone.io",
"spec": {
"serverless": {
"region": "us-east-1",
"cloud": "aws",
"read_capacity": {
"mode": "OnDemand",
"status": {
"state": "Ready",
"current_shards": null,
"current_replicas": null
}
}
}
},
"deletion_protection": "enabled",
"tags": {
"tag1": "value1",
"tag2": "value2"
},
"embed": {
"model": "llama-text-embed-v2",
"field_map": {
"text": "text"
},
"dimension": 1024,
"metric": "cosine",
"write_parameters": {
"dimension": 1024,
"input_type": "passage",
"truncate": "END"
},
"read_parameters": {
"dimension": 1024,
"input_type": "query",
"truncate": "END"
},
"vector_type": "dense"
}
}
// EXAMPLE RESPONSE 2: Serverless index (dedicated)
// Add a replica to an existing dedicated index.
{
"name": "example-serverless-dedicated-index",
"vector_type": "dense",
"metric": "cosine",
"dimension": 1536,
"status": {
"ready": true,
"state": "Ready"
},
"host": "example-serverless-dedicated-index-bhnyigt.svc.aped-4627-b74a.pinecone.io",
"spec": {
"serverless": {
"region": "us-east-1",
"cloud": "aws",
"read_capacity": {
"mode": "Dedicated",
"dedicated": {
"node_type": "b1",
"scaling": "Manual",
"manual": {
"shards": 1,
"replicas": 2 <-- desired state
}
},
"status": {
"state": "Scaling",
"current_shards": 1,
"current_replicas": 1 <-- current state
}
}
}
},
"deletion_protection": "enabled",
"tags": {
"tag0": "value0"
}
}
Configure an index
Configure an existing index. For guidance and examples, see Manage indexes.
# EXAMPLE REQUEST 1: Serverless index (on-demand)
# Enable deletion protection and add tags to an
# existing on-demand index.
PINECONE_API_KEY="YOUR_API_KEY"
INDEX_NAME="YOUR_INDEX_NAME"
curl -X PATCH "https://api.pinecone.io/indexes/$INDEX_NAME" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2025-10" \
-d '{
"deletion_protection": "enabled",
"tags": {
"tag1": "value1",
"tag2": "value2"
}
}'
# EXAMPLE REQUEST 2: Serverless index (dedicated)
# Add a replica to an existing dedicated index.
PINECONE_API_KEY="YOUR_API_KEY"
INDEX_NAME="YOUR_INDEX_NAME"
curl -X PATCH "https://api.pinecone.io/indexes/$INDEX_NAME" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2025-10" \
-d '{
"spec": {
"serverless": {
"read_capacity": {
"mode": "Dedicated",
"dedicated": {
"node_type": "b1",
"scaling": "Manual",
"manual": {
"shards": 2,
"replicas": 2
}
}
}
}
}
}'
// EXAMPLE RESPONSE 1: Serverless index (on-demand)
// Enable deletion protection and add tags to an
// existing on-demand index.
{
"name": "example-serverless-ondemand-index",
"vector_type": "dense",
"metric": "cosine",
"dimension": 1024,
"status": {
"ready": true,
"state": "Ready"
},
"host": "example-serverless-ondemand-index-bhnyigt.svc.aped-4627-b74a.pinecone.io",
"spec": {
"serverless": {
"region": "us-east-1",
"cloud": "aws",
"read_capacity": {
"mode": "OnDemand",
"status": {
"state": "Ready",
"current_shards": null,
"current_replicas": null
}
}
}
},
"deletion_protection": "enabled",
"tags": {
"tag1": "value1",
"tag2": "value2"
},
"embed": {
"model": "llama-text-embed-v2",
"field_map": {
"text": "text"
},
"dimension": 1024,
"metric": "cosine",
"write_parameters": {
"dimension": 1024,
"input_type": "passage",
"truncate": "END"
},
"read_parameters": {
"dimension": 1024,
"input_type": "query",
"truncate": "END"
},
"vector_type": "dense"
}
}
// EXAMPLE RESPONSE 2: Serverless index (dedicated)
// Add a replica to an existing dedicated index.
{
"name": "example-serverless-dedicated-index",
"vector_type": "dense",
"metric": "cosine",
"dimension": 1536,
"status": {
"ready": true,
"state": "Ready"
},
"host": "example-serverless-dedicated-index-bhnyigt.svc.aped-4627-b74a.pinecone.io",
"spec": {
"serverless": {
"region": "us-east-1",
"cloud": "aws",
"read_capacity": {
"mode": "Dedicated",
"dedicated": {
"node_type": "b1",
"scaling": "Manual",
"manual": {
"shards": 1,
"replicas": 2 <-- desired state
}
},
"status": {
"state": "Scaling",
"current_shards": 1,
"current_replicas": 1 <-- current state
}
}
}
},
"deletion_protection": "enabled",
"tags": {
"tag0": "value0"
}
}
Documentation Index
Fetch the complete documentation index at: https://docs.pinecone.io/llms.txt
Use this file to discover all available pages before exploring further.
# EXAMPLE REQUEST 1: Serverless index (on-demand)
# Enable deletion protection and add tags to an
# existing on-demand index.
PINECONE_API_KEY="YOUR_API_KEY"
INDEX_NAME="YOUR_INDEX_NAME"
curl -X PATCH "https://api.pinecone.io/indexes/$INDEX_NAME" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2025-10" \
-d '{
"deletion_protection": "enabled",
"tags": {
"tag1": "value1",
"tag2": "value2"
}
}'
# EXAMPLE REQUEST 2: Serverless index (dedicated)
# Add a replica to an existing dedicated index.
PINECONE_API_KEY="YOUR_API_KEY"
INDEX_NAME="YOUR_INDEX_NAME"
curl -X PATCH "https://api.pinecone.io/indexes/$INDEX_NAME" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2025-10" \
-d '{
"spec": {
"serverless": {
"read_capacity": {
"mode": "Dedicated",
"dedicated": {
"node_type": "b1",
"scaling": "Manual",
"manual": {
"shards": 2,
"replicas": 2
}
}
}
}
}
}'
// EXAMPLE RESPONSE 1: Serverless index (on-demand)
// Enable deletion protection and add tags to an
// existing on-demand index.
{
"name": "example-serverless-ondemand-index",
"vector_type": "dense",
"metric": "cosine",
"dimension": 1024,
"status": {
"ready": true,
"state": "Ready"
},
"host": "example-serverless-ondemand-index-bhnyigt.svc.aped-4627-b74a.pinecone.io",
"spec": {
"serverless": {
"region": "us-east-1",
"cloud": "aws",
"read_capacity": {
"mode": "OnDemand",
"status": {
"state": "Ready",
"current_shards": null,
"current_replicas": null
}
}
}
},
"deletion_protection": "enabled",
"tags": {
"tag1": "value1",
"tag2": "value2"
},
"embed": {
"model": "llama-text-embed-v2",
"field_map": {
"text": "text"
},
"dimension": 1024,
"metric": "cosine",
"write_parameters": {
"dimension": 1024,
"input_type": "passage",
"truncate": "END"
},
"read_parameters": {
"dimension": 1024,
"input_type": "query",
"truncate": "END"
},
"vector_type": "dense"
}
}
// EXAMPLE RESPONSE 2: Serverless index (dedicated)
// Add a replica to an existing dedicated index.
{
"name": "example-serverless-dedicated-index",
"vector_type": "dense",
"metric": "cosine",
"dimension": 1536,
"status": {
"ready": true,
"state": "Ready"
},
"host": "example-serverless-dedicated-index-bhnyigt.svc.aped-4627-b74a.pinecone.io",
"spec": {
"serverless": {
"region": "us-east-1",
"cloud": "aws",
"read_capacity": {
"mode": "Dedicated",
"dedicated": {
"node_type": "b1",
"scaling": "Manual",
"manual": {
"shards": 1,
"replicas": 2 <-- desired state
}
},
"status": {
"state": "Scaling",
"current_shards": 1,
"current_replicas": 1 <-- current state
}
}
}
},
"deletion_protection": "enabled",
"tags": {
"tag0": "value0"
}
}
Authorizations
Headers
Required date-based version header
Path Parameters
The name of the index to configure.
Body
The desired pod size and replica configuration for the index.
Configuration used to scale an index.
The spec object defines how the index should be deployed. Only some attributes of an index's spec may be updated. In general, you can modify settings related to scaling and configuration but you cannot change the cloud or region where the index is hosted.
- Serverless
- Pod-based
- BYOC
Show child attributes
Show child attributes
Whether deletion protection is enabled/disabled for the index.
Possible values: disabled or enabled.
Custom user tags added to an index. Keys must be 80 characters or less. Values must be 120 characters or less. Keys must be alphanumeric, '', or '-'. Values must be alphanumeric, ';', '@', '', '-', '.', '+', or ' '. To unset a key, set the value to be an empty string.
Show child attributes
Show child attributes
{ "tag0": "val0", "tag1": "val1" }Configure the integrated inference embedding settings for this index.
You can convert an existing index to an integrated index by specifying the embedding model and field_map. The index vector type and dimension must match the model vector type and dimension, and the index similarity metric must be supported by the model. Refer to the model guide for available models and model details.
You can later change the embedding configuration to update the field map, read parameters, or write parameters. Once set, the model cannot be changed.
Show child attributes
Show child attributes
{
"field_map": { "text": "your-text-field" },
"model": "multilingual-e5-large",
"read_parameters": { "input_type": "query", "truncate": "NONE" },
"write_parameters": { "input_type": "passage" }
}Response
The request to configure the index has been accepted. Check the index status to see when the change has been applied.
The IndexModel describes the configuration and status of a Pinecone index.
The name of the index. Resource name must be 1-45 characters long, start and end with an alphanumeric character, and consist only of lower case alphanumeric characters or '-'.
1 - 45"example-index"
The distance metric to be used for similarity search. You can use 'euclidean', 'cosine', or 'dotproduct'. If the 'vector_type' is 'sparse', the metric must be 'dotproduct'. If the vector_type is dense, the metric defaults to 'cosine'.
Possible values: cosine, euclidean, or dotproduct.
The URL address where the index is hosted.
"semantic-search-c01b5b5.svc.us-west1-gcp.pinecone.io"
The spec object defines how the index should be deployed.
- Serverless
- Pod-based
- BYOC
Show child attributes
Show child attributes
{
"pod": {
"environment": "us-east-1-aws",
"metadata_config": {
"indexed": ["genre", "title", "imdb_rating"]
},
"pod_type": "p1.x1",
"pods": 1,
"replicas": 1,
"shards": 1
}
}The current status of the index
Show child attributes
Show child attributes
{
"ready": true,
"state": "ScalingUpPodSize"
}The index vector type. You can use 'dense' or 'sparse'. If 'dense', the vector dimension must be specified. If 'sparse', the vector dimension should not be specified.
The dimensions of the vectors to be inserted in the index.
1 <= x <= 200001536
The private endpoint URL of an index.
"semantic-search-c01b5b5.svc.private.us-west1-gcp.pinecone.io"
Whether deletion protection is enabled/disabled for the index.
Possible values: disabled or enabled.
Custom user tags added to an index. Keys must be 80 characters or less. Values must be 120 characters or less. Keys must be alphanumeric, '', or '-'. Values must be alphanumeric, ';', '@', '', '-', '.', '+', or ' '. To unset a key, set the value to be an empty string.
Show child attributes
Show child attributes
{ "tag0": "val0", "tag1": "val1" }The embedding model and document fields mapped to embedding inputs.
Show child attributes
Show child attributes
{
"field_map": { "text": "your-text-field" },
"metric": "cosine",
"model": "multilingual-e5-large",
"read_parameters": { "input_type": "query", "truncate": "NONE" },
"write_parameters": { "input_type": "passage" }
}Was this page helpful?